/* This script is based on the following:
{
REXX  18.08.1997

CHecKMAIL v1.0alpha Written by Andrew Alexeenko (e-mail: chaos@falt.deep.ru,
                                                         2:5020/1101.2@fidonet,
                                                         7:1130/1101@fidonet
                                                         2:50/381.702@fidonet
                                                         117:117/1@milfornet)

This program is intended to notify user about incoming e-mail messages.
                                                    
usage: CHKMAIL.CMD      - load ;)
       CHKMAIL.CMD EXIT - force running part to exit

Thanks to Harry Bush for his FIDOTITL.CMD
}

As a matter of fact,I only changed the checkmail() procedure 
to work with IMAP server. And also changed the beeper. 
BTW, the original script does not work with Cyrus 1.5.14 POP3 server.

Sergey Kosaretskiy , 2:5020/252.57

*/

'@echo off'
ARG prm

crlf=d2c(13)||d2c(10)
install_dir='d:\chkmail'                             /* chkmail's home dir */
icon_position='84,6'                           /* icon position on the desktop */
imap_address='127.0.0.1'                             /* imap server address */
imap_name='USER'                              /* your imap name */
imap_password='PASSWORD'                             /* your imap password */
prog_name='d:\netsc461\program\netscape.exe'         /* your mail program  */
prog_path='d:\netsc461\program'                      /* and it's */ 
prog_param='-mail'                                   /* configuration */
check_for_new_mail_seconds=180                       /* Hmmm... %)  */
beep_on_new_mail=1                     /* No comments :) */
addr.port = 143                        /* Server port. 143 for IMAP. */
addr.addr = imap_address
addr.family = AF_INET

IF prm='EXIT' THEN DO
    SAY
    rc=lineout(install_dir'\exit.cm','')
    'exit'
    END
call rxfuncadd sysloadfuncs, rexxutil, sysloadfuncs;
call sysloadfuncs;
rc = RxFuncAdd("SockLoadFuncs","rxSock","SockLoadFuncs")
rc = SockLoadFuncs()

rc=SysDestroyObject("<MAILSTAT>");
rc=SysCreateObject("WPProgram","Wait...","<WP_DESKTOP>",,
"OBJECTID=<MAILSTAT>;EXENAME="prog_name";PARAMETERS="prog_param";STARTUPDIR="prog_path";ICONFILE="install_dir"\xmail.ico;"||,
"ICONPOS="icon_position";","UPDATE");


lup=1
DO WHILE lup
    retcode=checkmail()
    SELECT
        WHEN retcode=-1 THEN DO
            rc=SysCreateObject("WPProgram","No connection","<WP_DESKTOP>",,
            "OBJECTID=<MAILSTAT>;ICONFILE="install_dir"\alert.ico;","UPDATE");
            rc=SysSetObjectData("<MAILSTAT>",,
            "TITLE=No connection;");
            END
        WHEN retcode=0 THEN DO
            rc=SysCreateObject("WPProgram","No new msgs","<WP_DESKTOP>",,
            "OBJECTID=<MAILSTAT>;ICONFILE="install_dir"\nomail.ico;","UPDATE");
            rc=SysSetObjectData("<MAILSTAT>",,
            "TITLE=No new msgs;");
            END
        OTHERWISE
        rc=SysCreateObject("WPProgram",retcode" new msgs","<WP_DESKTOP>",,
        "OBJECTID=<MAILSTAT>;ICONFILE="install_dir"\newmail.ico;","UPDATE");
        rc=SysSetObjectData("<MAILSTAT>",,
        "TITLE="retcode" new msgs;");
        IF beep_on_new_mail=1 THEN do 3
do 10
  rc=beep(500,20)
  rc=beep(1000,20)
  rc=beep(1500,20)
end
call syssleep(1)
end
        END
    IF STREAM(install_dir'\exit.cm','C','open read')='READY:' THEN DO
        lup=0
        rc = STREAM(install_dir'\exit.cm','C','close')
        'del 'install_dir'\exit.cm'
        END
    ELSE
        call SysSleep check_for_new_mail_seconds;
    END
rc=SysDestroyObject("<MAILSTAT>");
rc = SockClose(sock)
rc = SockDropFuncs()
'exit'

checkmail:
    sock = SockSocket(AF_INET, SOCK_STREAM, 0)
    IF sock>-1 THEN
        DO
/*            SAY ''
            SAY 'Connecting to 'imap_address 
*/
            rc = SockConnect(sock,"addr.")
            IF rc>-1 THEN nop
/*                SAY 'Connected to IMAP at 'imap_address */
            ELSE DO
                SAY 'Unable to connect IMAP, server may be down...'
                RETURN -1
               END
            DROP str1
            DROP str2
            DROP str3
            drop rstr
            drop rstr1
            drop sstr
            rc=SockRecv(sock,str1,80)
	    sstr=unique()||' LOGIN '||imap_name||' '||imap_password||crlf
            rc=SockSend(sock,sstr)
            rc=SockRecv(sock,str2,80)
	parse value str2 with tag result exres
	if result='OK' then
       do
	 sstr=unique()||' STATUS Inbox (UNSEEN)'||crlf
	 rc=socksend(sock,sstr)
	 rc=sockrecv(sock,rstr,80)
	 rstr1=""
	  do i=1 to length(rstr)
	   if substr(rstr,i,6)='UNSEEN' then rstr1=substr(rstr,i+7,5)
	    else
	    nop
	  end
      if length(rstr1)>0 then
      do i=1 to length(rstr1)
       if substr(rstr1,i,1)=')' then rstr=left(rstr1,i-1)
       else nop
      end

	sstr=unique()||' LOGOUT'||crlf
            rc=SockSend(sock,sstr)
            rc=SockRecv(sock,str3,80)
end

  else do
        say 'IMAP Login failed.'
        return -1
       end
end
            rc=SockClose(sock)
            mes=rstr
            IF mes='0' THEN DO
                SAY time() 'You got no new messages'
                RETURN 0
                END
		else do
          SAY time() 'You got 'mes' new message(s)'
            RETURN mes
            END
    ELSE DO
        SAY 'Unable to get socket...'
        RETURN -1
end

unique:
	parse value time(long) with hours ':' mins ':' secs '.' usecs
return date(basedate)||hours||mins||secs||usecs
